package com.muyu.kafka;


import com.alibaba.fastjson2.JSON;
import com.alibaba.fastjson2.JSONObject;
import com.muyu.iotdb.server.IotDbServer;
import com.muyu.mqtt.dao.MessageData;
import lombok.extern.log4j.Log4j2;

import org.apache.kafka.clients.consumer.ConsumerRecord;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.kafka.annotation.KafkaListener;
import org.springframework.stereotype.Component;
import javax.annotation.Resource;


/**
 * 定时器 SimpleKafkaConsumer
 *
 * @author Yangle
 * Date 2024/6/16 22:18
 */
@Component
@Log4j2
public class SimpleKafkaConsumer {

    @Resource
    private IotDbServer iotDbServer;

    @Autowired
    private RedisTemplate<String,String> redisTemplate;
    @KafkaListener(topics = "test1", groupId = "Topics")
    public void consume(ConsumerRecord<String, String> record) {
        log.info("开始消费");
        try {
            System.out.printf("offset = %d, key = %s, value = %s%n", record.offset(), record.key(), record.value());
            String value = record.value();
            log.info("value:{}", value);
            JSONObject jsonObject = JSON.parseObject(value);
            iotDbServer.insertData(jsonObject);
        } catch (Exception e) {
            log.error("Error consuming Kafka message", e);
            // 处理异常，可能需要重试或其他逻辑
        }
    }

//    @KafkaListener(topics = "test1", groupId = "Topics")
//    public void consume2(ConsumerRecord<String, String> record) {
//        log.info("开始消费");
//        try {
//            System.out.printf("offset = %d, key = %s, value = %s%n", record.offset(), record.key(), record.value());
//            String value = record.value();
//            log.info("value:{}", value);
//            MessageData messageData1 = com.alibaba.fastjson2.JSONObject.parseObject(value, MessageData.class);
//            log.info("messageData1:{}", messageData1);
//            iotDbServer.add(messageData1);
//        } catch (Exception e) {
//            log.error("Error consuming Kafka message", e);
//            // 处理异常，可能需要重试或其他逻辑
//        }
//    }


}

